//====================================
//			PlayerModifier
//		The Minor-Modification
//		  Scripted by Troy
//====================================
class ModifyPawn extends Mutator config(PlayerModifier);

var config int MaxSuperHealth;
var config int Health;
var config float JumpZ;
var config float SpeedGround;
var config float SpeedAir;
var config float SpeedWater;
var config float MaxSpeedFalling;
var config bool bStartWithAllWeapons;
var localized string AllWeaponsDisplayText;
var localized string HealthDisplayText;
var localized string MaxSuperHealthDisplayText;
var localized string JumpZDisplayText;
var localized string SpeedGroundDisplayText;
var localized string SpeedAirDisplayText;
var localized string SpeedWaterDisplayText;
var localized string MaxSpeedFallingDisplayText;

function PreBeginPlay()
{
    Log("Loading settings of PlayerModifier...");
}

function PostBeginPlay()
{
	Health = (Health);
	MaxSuperHealth = (MaxSuperHealth);
	JumpZ = (JumpZ);
	SpeedGround = (SpeedGround);
	SpeedAir = (SpeedAir);
	SpeedWater = (SpeedWater);
	MaxSpeedFalling = (MaxSpeedFalling);
}
static function FillPlayInfo(PlayInfo PlayInfo)
{
	Super.FillPlayInfo(PlayInfo);

	PlayInfo.AddSetting(default.RulesGroup, "bStartWithAllWeapons", default.AllWeaponsDisplayText, 0, 1, "Check");
	PlayInfo.AddSetting(default.RulesGroup, "Health", default.HealthDisplayText, 0, 0, "Text",   "8;1:1000");
	PlayInfo.AddSetting(default.RulesGroup, "MaxSuperHealth", default.MaxSuperHealthDisplayText, 0, 0, "Text",   "8;1:1000");
	PlayInfo.AddSetting(default.RulesGroup, "JumpZ", default.JumpZDisplayText, 0, 0, "Text",   "8;1:1000");
	PlayInfo.AddSetting(default.RulesGroup, "SpeedGround", default.SpeedGroundDisplayText, 0, 0, "Text",   "8;1:1000");
	PlayInfo.AddSetting(default.RulesGroup, "SpeedAir", default.SpeedAirDisplayText, 0, 0, "Text",   "8;1:1000");
	PlayInfo.AddSetting(default.RulesGroup, "SpeedWater", default.SpeedWaterDisplayText, 0, 0, "Text",   "8;1:1000");
	PlayInfo.AddSetting(default.RulesGroup, "MaxSpeedFalling", default.MaxSpeedFallingDisplayText, 0, 0, "Text",   "8;1:1000");	
}

static event string GetDescriptionText(string PropName)
{
	switch (PropName)
	{
		case "bStartWithAllWeapons":	return default.AllWeaponsDisplayText;
		case "Health":	return default.HealthDisplayText;
		case "MaxSuperHealth":	return default.MaxSuperHealthDisplayText;
		case "JumpZ":	return default.JumpZDisplayText;
		case "SpeedGround":	return default.SpeedGroundDisplayText;
		case "SpeedAir":	return default.SpeedAirDisplayText;
		case "SpeedWater":	return default.SpeedWaterDisplayText;
		case "MaxSpeedFalling":	return default.MaxSpeedFallingDisplayText;
	}

	return Super.GetDescriptionText(PropName);
	Log("Succesfully loaded settings of PlayerModifier!");
}

function ModifyPlayer(Pawn Other)
{
  local xPawn MyPawn;	//MyPawn is a variable
  MyPawn = xPawn(Other); 
  
  if (MyPawn != None)
  {
     MyPawn.Health = Health;
	 MyPawn.JumpZ = JumpZ;
	 MyPawn.GroundSpeed = SpeedGround;
	 MyPawn.AirSpeed = SpeedAir;
	 MyPawn.WaterSpeed = SpeedWater;
	 MyPawn.MaxFallSpeed = MaxSpeedFalling;
	 MyPawn.SuperHealthMax = MaxSuperHealth;
  }

    If(bStartWithAllWeapons)
	{
	 MyPawn.GiveWeapon("xWeapons.sniperrifle");
	 MyPawn.GiveWeapon("xWeapons.rocketlauncher"); 
	 MyPawn.GiveWeapon("xWeapons.flakcannon");
	 MyPawn.GiveWeapon("xWeapons.minigun");
	 MyPawn.GiveWeapon("xWeapons.linkgun");
	 MyPawn.GiveWeapon("xWeapons.shockrifle");
	 MyPawn.GiveWeapon("xWeapons.biorifle");
	}
	
	Log("Succesfully started PlayerModifier!");
}

defaultproperties
{
	MaxSpeedFallingDisplayText="Max Fallspeed"
	SpeedWaterDisplayText="Speed in Water"
	SpeedAirDisplayText="Speed in Air"
	SpeedGroundDisplayText="Speed on Ground"
	JumpZDisplayText="JumpZ"
	AllWeaponsDisplayText="Start with all weapons"
	HealthDisplayText="Health"
	MaxSuperHealthDisplayText="Max SuperHealth"
	bStartWithAllWeapons=false
	SpeedGround=+00440.000000  		//This is how fast the players moves on the ground.
	SpeedAir=+00440.000000  		//This is how fast the player moves in the air.
	SpeedWater=+00300.000000  		//Thi is show fast the player moves through water.
	JumpZ=+00420.000000  			//This is the ammount of acceleration applied when a player jumps.
	MaxSpeedFalling=+1200.0 		//This is maximum speed the player can land at without taking damage, a really high value basically means no falling damage (This also affects the paths that Bots can take).
	Health=100  					//This is the starting health ammount.
	MaxSuperHealth=199  			//Health vials and other things such as the regeneration mutator heal to this limit.
	Friendlyname="PlayerModifer"
	Groupname="PlayerModifer"
	Description="A minor mutator which lets you modify the properties of the player. You can configurate all the settings in PlayerModifer.ini located in your UT2004 System file. Scripted by Troy."
}